diff -ruN ccp4srs-old/ccp4srs/ccp4srs_chem.h ccp4srs/ccp4srs/ccp4srs_chem.h
--- ccp4srs-old/ccp4srs/ccp4srs_chem.h	2014-03-24 10:40:19.000000000 -0700
+++ ccp4srs/ccp4srs/ccp4srs_chem.h	2014-09-09 21:34:12.000000000 -0700
@@ -1,10 +1,10 @@
-//  $Id: ccp4srs_chem.h, v 1.00 2010/03/11 15:28:14 Eugene Exp $
+//  $Id: ccp4srs_chem.h $
 //  =================================================================
 //
 //   CCP4 SRS Library: Storage, Retrieval and Search support for
 //   CCP4 ligand data.
 //
-//   Copyright (C) Eugene Krissinel 2010.
+//   Copyright (C) Eugene Krissinel 2010-2013.
 //
 //   This library is free software: you can redistribute it and/or
 //   modify it under the terms of the GNU Lesser General Public
@@ -22,13 +22,13 @@
 //
 //  =================================================================
 //
-//    26.02.13   <--  Date of Last Modification.
+//    18.09.13   <--  Date of Last Modification.
 //                   ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 //  -----------------------------------------------------------------
 //
 //  **** Module  :  ccp4srs_chem  <interface>
 //       ~~~~~~~~~
-//  **** Classes :  CCP4SRSChem - SRS chemistry manager class
+//  **** Classes :  ccp4srs::Chem - SRS chemistry manager class
 //       ~~~~~~~~~
 //
 //  (C) E. Krissinel 2010-2013
@@ -42,133 +42,146 @@
 #include "ccp4srs_base.h"
 #include "ccp4srs_types.h"
 
+namespace ccp4srs  {
 
-// ==================================================================
+  // ==================================================================
 
-DefineClass(CCP4SRSChem)
+  DefineClass(Chem);
 
-class CCP4SRSChem : public CCP4SRSBase  {
+  class Chem : public Base  {
 
-  public:
-    CCP4SRSChem ();
-    ~CCP4SRSChem();
-
-    int  getEnergyTypes ( PCResidue  R,           PCFile structFile );
-    int  getEnergyTypes ( PPCResidue R, int nRes, PCFile structFile );
-    int  getEnergyTypes ( PCChain      chain,     PCFile structFile );
-    int  getEnergyTypes ( PCModel      model,     PCFile structFile );
-    int  getEnergyTypes ( PCMMDBManager MMDB,     PCFile structFile );
-
-    int  addHydrogens   ( PCResidue        R, PCFile structFile );
-    int  addHydrogens   ( PCChain      chain, PCFile structFile );
-    int  addHydrogens   ( PCModel      model, PCFile structFile );
-    int  addHydrogens   ( PCMMDBManager MMDB, PCFile structFile );
-
-
-    //   MakeBonds(..) makes bonds between atoms in MMDB's residue R
-    // from data found in SBase. Residue R must be associated with
-    // coordinate hierarchy. Data is retrieved from SBase on the basis
-    // of residue name only. In case of multiple conformations, if
-    // altLoc:
-    //    NULL  - the highest occupancy atom will be taken
-    //            if all occupancies are equal then atom with
-    //            first altLoc taken
-    //    other - atoms with given altLoc are taken. If such
-    //            altLoc is not found, the function does as if
-    //            NULL value for altLoc is given.
-    //   If selHandles is not NULL, the function also selects atoms
-    // in the residue according to their hydrogen bond attributes.
-    // This is a special option for hydrogen bond calculations
-    //   If ignoreNegSigOcc is set True then the function will ignore
-    // atoms with negative occupancy standard deviation. Such atoms
-    // may be hydrogens added by CSBase0::AddHydrogen(..) function,
-    // in general any atoms added by CSBAtom::MakeCAtom(..) function.
-    // Added hydrogens may be ignored if MakeBonds is used in
-    // CSbase::CalcHBonds(..) function.
-    //   Return:
-    //     SBASE_Ok             success
-    //     SBASE_FileNotFound   non-initiated SBase
-    //     SBASE_StructNotFound the residue's name is not found
-    //                          in SBase
-    //     SBASE_EmptyResidue   residue R does not contain atoms
-    //     SBASE_NoAtomsFound   SBase entry does not contain atoms
-    //     SBASE_BrokenBonds    some bonds could not be set up because
-    //                          of missing atoms in R. This could be
-    //                          a result of residue R named wrongly.
-    int  makeBonds ( PCResidue   R,
-                     pstr        altLoc,
-                     PCFile      structFile,
-                     PSDASelHnds selHandles,
-                     Boolean     ignoreNegSigOcc );
-
-    //   CalcHBonds(..) calculates hydrogen bonds and salt bridges
-    // between atoms of residues given in Res1[0..nres1-1] and
-    // Res2[0..nres2-1]. H-bonds are returned in HBond[0..nHBonds-1]
-    // and salt bridges are returned in SBridge[0..nSBridges-1].
-    //
-    //   On input:
-    //     Res1, Res2         must belong to the same MMDB
-    //     HBond, SBridge     should be set NULL, otherwise the
-    //                        function attempts to deallocate them
-    //     nHBonds, nSBridges ignored
-    //     structFile         may be a pointer to open SBase stucture
-    //                        file in order to save on file open
-    //                        operation. If structFile is set NULL,
-    //                        the function will open the SBase
-    //                        structure file by itself
-    //     altLoc             specifies the alternative location for
-    //                        donors and acceptors.
-    //                          altLoc==NULL  the highest occupancy
-    //                                        atoms are taken. If all
-    //                                        occupancies are equal
-    //                                        equal then atom with
-    //                                        first altLoc taken
-    //                          altLoc!=NULL  atoms with given altLoc
-    //                                        are taken. If such
-    //                                        altLoc is not found,
-    //                                        the function acts as
-    //                                        if NULL value for altLoc
-    //                                        were given.
-    //     ignoreNegSigOcc    if it is set True, then the function
-    //                        ignores atoms with negative occupancy
-    //                        standard deviation. Such atoms may be
-    //                        hydrogens added by addHydrogen(..)
-    //                        function, or, in general, any atoms added
-    //                        by CCP4SRSAtom::MakeCAtom(..) function.
-    //                        Such added hydrogens are not guaranteed to
-    //                        be in correct place, therefore the
-    //                        function may mistake on some hydrogen
-    //                        bonds if they are not neglected.
-    //
-    //   On output:
-    //     Allocated arrays HBond[0..nHBonds-1] and
-    //     SBridge[0..nSBridges-1]. If no bonds/bridges were found,
-    //     the corresponding array is not allocated and set NULL.
-    //     Application is responsible for deallocation of the arrays,
-    //     when not needed, using statements
-    //       if (HBond)    delete[] HBond;
-    //       if (SBridge)  delete[] SBridge;
-    //     HBond[i].a1, SBridge[i].a1 always refer atom from Res1[],
-    //     and HBond[i].a2, SBridge[i].a2 always refer atom from
-    //     Res2[].
-    //
-    int  CalcHBonds ( PPCResidue Res1, int nres1,
-                      PPCResidue Res2, int nres2,
-                      RPSAtomPair   HBond, int & nHBonds,
-                      RPSAtomPair SBridge, int & nSBridges,
-                      PCFile structFile=NULL, pstr altLoc=NULL,
-                      Boolean ignoreNegSigOcc=False );
-
-  protected:
-    // Geometry parameters for H-bond calculations
-    realtype minDAdist,maxSBdist,maxDAdist,maxHAdist2;
-    realtype maxDHAcos,maxHAAcos,maxDAAcos,maxDDAcos;
+    public:
+      Chem ();
+      ~Chem();
+
+      CCP4SRS_RC getEnergyTypes ( mmdb::PResidue  R,
+                                  mmdb::io::PFile structFile );
+      CCP4SRS_RC getEnergyTypes ( mmdb::PPResidue R, int nRes,
+                                  mmdb::io::PFile structFile );
+      CCP4SRS_RC getEnergyTypes ( mmdb::PChain  chain,
+                                  mmdb::io::PFile structFile );
+      CCP4SRS_RC getEnergyTypes ( mmdb::PModel  model,
+                                  mmdb::io::PFile structFile );
+      CCP4SRS_RC getEnergyTypes ( mmdb::PManager MMDB,
+                                  mmdb::io::PFile structFile );
+
+      CCP4SRS_RC addHydrogens   ( mmdb::PResidue    R,
+                                  mmdb::io::PFile structFile );
+      CCP4SRS_RC addHydrogens   ( mmdb::PChain  chain,
+                                  mmdb::io::PFile structFile );
+      CCP4SRS_RC addHydrogens   ( mmdb::PModel  model,
+                                  mmdb::io::PFile structFile );
+      CCP4SRS_RC addHydrogens   ( mmdb::PManager MMDB,
+                                  mmdb::io::PFile structFile );
+
+
+      //   MakeBonds(..) makes bonds between atoms in MMDB's residue R
+      // from data found in SBase. Residue R must be associated with
+      // coordinate hierarchy. Data is retrieved from SBase on the basis
+      // of residue name only. In case of multiple conformations, if
+      // altLoc:
+      //    NULL  - the highest occupancy atom will be taken
+      //            if all occupancies are equal then atom with
+      //            first altLoc taken
+      //    other - atoms with given altLoc are taken. If such
+      //            altLoc is not found, the function does as if
+      //            NULL value for altLoc is given.
+      //   If selHandles is not NULL, the function also selects atoms
+      // in the residue according to their hydrogen bond attributes.
+      // This is a special option for hydrogen bond calculations
+      //   If ignoreNegSigOcc is set True then the function will ignore
+      // atoms with negative occupancy standard deviation. Such atoms
+      // may be hydrogens added by CSBase0::AddHydrogen(..) function,
+      // in general any atoms added by CSBAtom::MakeCAtom(..) function.
+      // Added hydrogens may be ignored if MakeBonds is used in
+      // CSbase::CalcHBonds(..) function.
+      //   Return:
+      //     SBASE_Ok             success
+      //     SBASE_FileNotFound   non-initiated SBase
+      //     SBASE_StructNotFound the residue's name is not found
+      //                          in SBase
+      //     SBASE_EmptyResidue   residue R does not contain atoms
+      //     SBASE_NoAtomsFound   SBase entry does not contain atoms
+      //     SBASE_BrokenBonds    some bonds could not be set up because
+      //                          of missing atoms in R. This could be
+      //                          a result of residue R named wrongly.
+      CCP4SRS_RC makeBonds ( mmdb::PResidue  R,
+                             mmdb::pstr      altLoc,
+                             mmdb::io::PFile structFile,
+                             PDASelHnds      selHandles,
+                             bool            ignoreNegSigOcc );
+
+      //   CalcHBonds(..) calculates hydrogen bonds and salt bridges
+      // between atoms of residues given in Res1[0..nres1-1] and
+      // Res2[0..nres2-1]. H-bonds are returned in HBond[0..nHBonds-1]
+      // and salt bridges are returned in SBridge[0..nSBridges-1].
+      //
+      //   On input:
+      //     Res1, Res2         must belong to the same MMDB
+      //     HBond, SBridge     should be set NULL, otherwise the
+      //                        function attempts to deallocate them
+      //     nHBonds, nSBridges ignored
+      //     structFile         may be a pointer to open SBase stucture
+      //                        file in order to save on file open
+      //                        operation. If structFile is set NULL,
+      //                        the function will open the SBase
+      //                        structure file by itself
+      //     altLoc             specifies the alternative location for
+      //                        donors and acceptors.
+      //                          altLoc==NULL  the highest occupancy
+      //                                        atoms are taken. If all
+      //                                        occupancies are equal
+      //                                        equal then atom with
+      //                                        first altLoc taken
+      //                          altLoc!=NULL  atoms with given altLoc
+      //                                        are taken. If such
+      //                                        altLoc is not found,
+      //                                        the function acts as
+      //                                        if NULL value for altLoc
+      //                                        were given.
+      //     ignoreNegSigOcc    if it is set True, then the function
+      //                        ignores atoms with negative occupancy
+      //                        standard deviation. Such atoms may be
+      //                        hydrogens added by addHydrogen(..)
+      //                        function, or, in general, any atoms added
+      //                        by CCP4SRSAtom::MakeCAtom(..) function.
+      //                        Such added hydrogens are not guaranteed to
+      //                        be in correct place, therefore the
+      //                        function may mistake on some hydrogen
+      //                        bonds if they are not neglected.
+      //
+      //   On output:
+      //     Allocated arrays HBond[0..nHBonds-1] and
+      //     SBridge[0..nSBridges-1]. If no bonds/bridges were found,
+      //     the corresponding array is not allocated and set NULL.
+      //     Application is responsible for deallocation of the arrays,
+      //     when not needed, using statements
+      //       if (HBond)    delete[] HBond;
+      //       if (SBridge)  delete[] SBridge;
+      //     HBond[i].a1, SBridge[i].a1 always refer atom from Res1[],
+      //     and HBond[i].a2, SBridge[i].a2 always refer atom from
+      //     Res2[].
+      //
+      CCP4SRS_RC CalcHBonds ( mmdb::PPResidue Res1, int nres1,
+                              mmdb::PPResidue Res2, int nres2,
+                              RPAtomPair     HBond, int & nHBonds,
+                              RPAtomPair   SBridge, int & nSBridges,
+                              mmdb::io::PFile structFile=NULL,
+                              mmdb::pstr      altLoc=NULL,
+                              bool ignoreNegSigOcc=false );
+
+    protected:
+      // Geometry parameters for H-bond calculations
+      mmdb::realtype minDAdist,maxSBdist,maxDAdist,maxHAdist2;
+      mmdb::realtype maxDHAcos,maxHAAcos,maxDAAcos,maxDDAcos;
 
-    void init_chem();
+      void init_chem();
 
-  private:
-    int index_alloc;
+    private:
+      int index_alloc;
 
-};
+  };
+
+}  // namespace ccp4srs
 
 #endif // CCP4SRS_CHEM_H
diff -ruN ccp4srs-old/ccp4srs/ccp4srs_chicenter.cpp ccp4srs/ccp4srs/ccp4srs_chicenter.cpp
--- ccp4srs-old/ccp4srs/ccp4srs_chicenter.cpp	2014-03-24 10:40:19.000000000 -0700
+++ ccp4srs/ccp4srs/ccp4srs_chicenter.cpp	2014-09-09 21:34:12.000000000 -0700
@@ -1,10 +1,10 @@
-//  $Id: ccp4srs_chicenter.cpp, v1.00 2010/03/11 15:28:14 Eugene Exp$
+//  $Id: ccp4srs_chicenter.cpp $
 //  =================================================================
 //
 //   CCP4 SRS Library: Storage, Retrieval and Search support for
 //   CCP4 ligand data.
 //
-//   Copyright (C) Eugene Krissinel 2010.
+//   Copyright (C) Eugene Krissinel 2010-2013.
 //
 //   This library is free software: you can redistribute it and/or
 //   modify it under the terms of the GNU Lesser General Public
@@ -22,183 +22,183 @@
 //
 //  =================================================================
 //
-//    11.03.10   <--  Date of Last Modification.
+//    18.09.13   <--  Date of Last Modification.
 //                   ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 //  -----------------------------------------------------------------
 //
 //  **** Module  :  ccp4srs_chicenter  <implementation>
 //       ~~~~~~~~~
-//  **** Classes :  CCP4SRSChiCenter - chiral center class
+//  **** Classes :  ccp4srs::ChiCenter - chiral center class
 //       ~~~~~~~~~
 //
-//  (C) E. Krissinel 2010
+//  (C) E. Krissinel 2010-2013
 //
 //  =================================================================
 //
 
-#ifndef  __STRING_H
 #include <string.h>
-#endif
-
 
 #include "ccp4srs_chicenter.h"
 #include "ccp4srs_defs.h"
 
-CCP4SRSChiCenter::CCP4SRSChiCenter()  {
-  chicenter_id[0] = char(0);  // chiral center id
-  atom_center     = -1;       // chiral center atom
-  atom_1          = -1;       // ordinal numbers of atoms
-  atom_2          = -1;       //   that form
-  atom_3          = -1;       //     the center
-  volume_sign     = CCP4SRSChiCenter::noSign;
-}
-
-CCP4SRSChiCenter::~CCP4SRSChiCenter()  {
-}
-
-
-#define  VOLUME_SIGN_POSITIVE  "positiv"
-#define  VOLUME_SIGN_NEGATIVE  "negativ"
-#define  VOLUME_SIGN_BOTH      "both"
-
-char CCP4SRSChiCenter::get_chirality()  {
-  switch (volume_sign)  {
-    default:
-    case noSign   : break;
-    case Positive : return 'R';
-    case Negative : return 'S';
-    case Both     : return 'B';
-  }
-  return 'N';
-}
-
-
-int CCP4SRSChiCenter::readFromCIF ( PCMMCIFLoop mmCIFLoop, int chiNo,
-                             CCP4SRSContainer<CCP4SRSAtom> & atoms )  {
-char S[100];
-int  rc;
-
-  rc = 0;
-
-  mmCIFLoop->CopyString ( chicenter_id,sizeof(ChiCenterID)-1,
-                          MMCIF_TAG_ID,chiNo,rc );
-
-  get_atom_from_cif ( atom_center,mmCIFLoop,MMCIF_TAG_ATOM_ID_CENTRE,
-                      chiNo,atoms,rc );
-  get_atom_from_cif ( atom_1,mmCIFLoop,MMCIF_TAG_ATOM_ID_1,
-                      chiNo,atoms,rc );
-  get_atom_from_cif ( atom_2,mmCIFLoop,MMCIF_TAG_ATOM_ID_2,
-                      chiNo,atoms,rc );
-  get_atom_from_cif ( atom_3,mmCIFLoop,MMCIF_TAG_ATOM_ID_3,
-                      chiNo,atoms,rc );
-
-  S[0] = char(0);
-  mmCIFLoop->CopyString ( S,sizeof(S)-1,MMCIF_TAG_VOLUME_SIGN,
-                          chiNo,rc );
-  LowerCase ( S );
-  if (!strcmp(S,VOLUME_SIGN_POSITIVE))
-    volume_sign = CCP4SRSChiCenter::Positive;
-  else if (!strcmp(S,VOLUME_SIGN_NEGATIVE))
-    volume_sign = CCP4SRSChiCenter::Negative;
-  else if (!strcmp(S,VOLUME_SIGN_BOTH))
-    volume_sign = CCP4SRSChiCenter::Both;
-  else
-    volume_sign = CCP4SRSChiCenter::noSign;
-
-  return rc;
-
-}
-
-
-
-/*
-loop_
-_chem_comp_chir.comp_id
-_chem_comp_chir.id
-_chem_comp_chir.atom_id_centre
-_chem_comp_chir.atom_id_1
-_chem_comp_chir.atom_id_2
-_chem_comp_chir.atom_id_3
-_chem_comp_chir.volume_sign
- ATP      chir_01  C4*    C5*    O4*    C3*       negativ
- ATP      chir_02  C3*    C4*    O3*    C2*       negativ
- ATP      chir_03  C2*    C3*    O2*    C1*       negativ
- ATP      chir_04  C1*    O4*    C2*    N9        positiv
-*/
-
-void CCP4SRSChiCenter::makeCIFTags ( PCMMCIFLoop mmCIFLoop )  {
-  mmCIFLoop->AddLoopTag ( MMCIF_TAG_COMP_ID        );
-  mmCIFLoop->AddLoopTag ( MMCIF_TAG_ID             );
-  mmCIFLoop->AddLoopTag ( MMCIF_TAG_ATOM_ID_CENTRE );
-  mmCIFLoop->AddLoopTag ( MMCIF_TAG_ATOM_ID_1      );
-  mmCIFLoop->AddLoopTag ( MMCIF_TAG_ATOM_ID_2      );
-  mmCIFLoop->AddLoopTag ( MMCIF_TAG_ATOM_ID_3      );
-  mmCIFLoop->AddLoopTag ( MMCIF_TAG_VOLUME_SIGN    );
-}
-
-void CCP4SRSChiCenter::writeToCIF ( PCMMCIFLoop mmCIFLoop, cpstr monID,
-                             CCP4SRSContainer<CCP4SRSAtom> & atoms )  {
-
-  mmCIFLoop->AddString ( monID,False                 );
-  mmCIFLoop->AddString ( chicenter_id,False          );
-
-  add_atom_to_cif      ( mmCIFLoop,atom_center,atoms );
-  add_atom_to_cif      ( mmCIFLoop,atom_1,atoms      );
-  add_atom_to_cif      ( mmCIFLoop,atom_2,atoms      );
-  add_atom_to_cif      ( mmCIFLoop,atom_3,atoms      );
-
-  switch (volume_sign)  {
-    case CCP4SRSChiCenter::Positive :
-      mmCIFLoop->AddString ( VOLUME_SIGN_POSITIVE,False ); break;
-    case CCP4SRSChiCenter::Negative :
-      mmCIFLoop->AddString ( VOLUME_SIGN_NEGATIVE,False ); break;
-    case CCP4SRSChiCenter::Both :
-      mmCIFLoop->AddString ( VOLUME_SIGN_BOTH,False );     break;
-    default :
-      mmCIFLoop->AddNoData ( CIF_NODATA_DOT );
-  }
-
-}
-
-void  CCP4SRSChiCenter::copy ( PCCP4SRSChiCenter chicenter,
-                               ivector anmatch )  {
-  strcpy ( chicenter_id,chicenter->id() );
-  if (anmatch)  {
-    atom_center = anmatch[chicenter->center()];
-    atom_1 = anmatch[chicenter->atom1()];
-    atom_2 = anmatch[chicenter->atom2()];
-    atom_3 = anmatch[chicenter->atom3()];
-  } else  {
-    atom_1 = chicenter->atom1();
-    atom_2 = chicenter->atom2();
-    atom_3 = chicenter->atom3();
-  }
-  volume_sign = chicenter->sign();
-}
-
-void  CCP4SRSChiCenter::write_mem ( PCMemIO memIO, int version )  {
-UNUSED_ARGUMENT(version);
-  memIO->put_line    ( chicenter_id );
-  memIO->put_integer ( atom_center  );
-  memIO->put_integer ( atom_1       );
-  memIO->put_integer ( atom_2       );
-  memIO->put_integer ( atom_3       );
-  memIO->put_ibyte   ( volume_sign  );
-}
-
-Boolean CCP4SRSChiCenter::read_mem ( PCMemIO memIO, int version,
-                                     Boolean * Ok )  {
-UNUSED_ARGUMENT(version);
-Boolean success;
-  if (Ok)  success = *Ok;
-     else  success = True;
-  memIO->get_line    ( chicenter_id,&success );
-  memIO->get_integer ( atom_center ,&success );
-  memIO->get_integer ( atom_1      ,&success );
-  memIO->get_integer ( atom_2      ,&success );
-  memIO->get_integer ( atom_3      ,&success );
-  memIO->get_ibyte   ( volume_sign ,&success );
-  if (Ok)  *Ok = success;
-  return success;
-}
+namespace ccp4srs  {
+
+  ChiCenter::ChiCenter()  {
+    chicenter_id[0] = char(0);  // chiral center id
+    atom_center     = -1;       // chiral center atom
+    atom_1          = -1;       // ordinal numbers of atoms
+    atom_2          = -1;       //   that form
+    atom_3          = -1;       //     the center
+    volume_sign     = ChiCenter::noSign;
+  }
+
+  ChiCenter::~ChiCenter()  {
+  }
+
+
+  #define  VOLUME_SIGN_POSITIVE  "positiv"
+  #define  VOLUME_SIGN_NEGATIVE  "negativ"
+  #define  VOLUME_SIGN_BOTH      "both"
+
+  char ChiCenter::get_chirality()  {
+    switch (volume_sign)  {
+      default:
+      case noSign   : break;
+      case Positive : return 'R';
+      case Negative : return 'S';
+      case Both     : return 'B';
+    }
+    return 'N';
+  }
+
+
+  int ChiCenter::readFromCIF ( mmdb::mmcif::PLoop mmCIFLoop,
+                               int chiNo, Container<Atom> & atoms )  {
+  char S[100];
+  int  rc;
+
+    rc = 0;
+
+    mmCIFLoop->CopyString ( chicenter_id,sizeof(ChiCenterID)-1,
+                            MMCIF_TAG_ID,chiNo,rc );
+
+    get_atom_from_cif ( atom_center,mmCIFLoop,MMCIF_TAG_ATOM_ID_CENTRE,
+                        chiNo,atoms,rc );
+    get_atom_from_cif ( atom_1,mmCIFLoop,MMCIF_TAG_ATOM_ID_1,
+                        chiNo,atoms,rc );
+    get_atom_from_cif ( atom_2,mmCIFLoop,MMCIF_TAG_ATOM_ID_2,
+                        chiNo,atoms,rc );
+    get_atom_from_cif ( atom_3,mmCIFLoop,MMCIF_TAG_ATOM_ID_3,
+                        chiNo,atoms,rc );
+
+    S[0] = char(0);
+    mmCIFLoop->CopyString ( S,sizeof(S)-1,MMCIF_TAG_VOLUME_SIGN,
+                            chiNo,rc );
+    mmdb::LowerCase ( S );
+    if (!strcmp(S,VOLUME_SIGN_POSITIVE))
+      volume_sign = ChiCenter::Positive;
+    else if (!strcmp(S,VOLUME_SIGN_NEGATIVE))
+      volume_sign = ChiCenter::Negative;
+    else if (!strcmp(S,VOLUME_SIGN_BOTH))
+      volume_sign = ChiCenter::Both;
+    else
+      volume_sign = ChiCenter::noSign;
+
+    return rc;
+
+  }
+
+
+
+  /*
+  loop_
+  _chem_comp_chir.comp_id
+  _chem_comp_chir.id
+  _chem_comp_chir.atom_id_centre
+  _chem_comp_chir.atom_id_1
+  _chem_comp_chir.atom_id_2
+  _chem_comp_chir.atom_id_3
+  _chem_comp_chir.volume_sign
+   ATP      chir_01  C4*    C5*    O4*    C3*       negativ
+   ATP      chir_02  C3*    C4*    O3*    C2*       negativ
+   ATP      chir_03  C2*    C3*    O2*    C1*       negativ
+   ATP      chir_04  C1*    O4*    C2*    N9        positiv
+  */
+
+  void ChiCenter::makeCIFTags ( mmdb::mmcif::PLoop mmCIFLoop )  {
+    mmCIFLoop->AddLoopTag ( MMCIF_TAG_COMP_ID        );
+    mmCIFLoop->AddLoopTag ( MMCIF_TAG_ID             );
+    mmCIFLoop->AddLoopTag ( MMCIF_TAG_ATOM_ID_CENTRE );
+    mmCIFLoop->AddLoopTag ( MMCIF_TAG_ATOM_ID_1      );
+    mmCIFLoop->AddLoopTag ( MMCIF_TAG_ATOM_ID_2      );
+    mmCIFLoop->AddLoopTag ( MMCIF_TAG_ATOM_ID_3      );
+    mmCIFLoop->AddLoopTag ( MMCIF_TAG_VOLUME_SIGN    );
+  }
+
+  void ChiCenter::writeToCIF ( mmdb::mmcif::PLoop mmCIFLoop,
+                               mmdb::cpstr monID,
+                               Container<Atom> & atoms )  {
+
+    mmCIFLoop->AddString ( monID,false                 );
+    mmCIFLoop->AddString ( chicenter_id,false          );
+
+    add_atom_to_cif      ( mmCIFLoop,atom_center,atoms );
+    add_atom_to_cif      ( mmCIFLoop,atom_1,atoms      );
+    add_atom_to_cif      ( mmCIFLoop,atom_2,atoms      );
+    add_atom_to_cif      ( mmCIFLoop,atom_3,atoms      );
+
+    switch (volume_sign)  {
+      case ChiCenter::Positive :
+        mmCIFLoop->AddString ( VOLUME_SIGN_POSITIVE,false ); break;
+      case ChiCenter::Negative :
+        mmCIFLoop->AddString ( VOLUME_SIGN_NEGATIVE,false ); break;
+      case ChiCenter::Both :
+        mmCIFLoop->AddString ( VOLUME_SIGN_BOTH,false );     break;
+      default :
+        mmCIFLoop->AddNoData ( mmdb::mmcif::CIF_NODATA_DOT );
+    }
+
+  }
+
+  void  ChiCenter::copy ( PChiCenter chicenter,
+                          mmdb::ivector anmatch )  {
+    strcpy ( chicenter_id,chicenter->id() );
+    if (anmatch)  {
+      atom_center = anmatch[chicenter->center()];
+      atom_1 = anmatch[chicenter->atom1()];
+      atom_2 = anmatch[chicenter->atom2()];
+      atom_3 = anmatch[chicenter->atom3()];
+    } else  {
+      atom_1 = chicenter->atom1();
+      atom_2 = chicenter->atom2();
+      atom_3 = chicenter->atom3();
+    }
+    volume_sign = chicenter->sign();
+  }
+
+  void  ChiCenter::write_mem ( PMemIO memIO, int version )  {
+  UNUSED_ARGUMENT(version);
+    memIO->put_line    ( chicenter_id );
+    memIO->put_integer ( atom_center  );
+    memIO->put_integer ( atom_1       );
+    memIO->put_integer ( atom_2       );
+    memIO->put_integer ( atom_3       );
+    memIO->put_ibyte   ( volume_sign  );
+  }
+
+  bool ChiCenter::read_mem ( PMemIO memIO, int version, bool * Ok )  {
+  UNUSED_ARGUMENT(version);
+  bool success;
+    if (Ok)  success = *Ok;
+       else  success = true;
+    memIO->get_line    ( chicenter_id,&success );
+    memIO->get_integer ( atom_center ,&success );
+    memIO->get_integer ( atom_1      ,&success );
+    memIO->get_integer ( atom_2      ,&success );
+    memIO->get_integer ( atom_3      ,&success );
+    memIO->get_ibyte   ( volume_sign ,&success );
+    if (Ok)  *Ok = success;
+    return success;
+  }
 
+}  // namespace ccp4srs
diff -ruN ccp4srs-old/ccp4srs/ccp4srs_chicenter.h ccp4srs/ccp4srs/ccp4srs_chicenter.h
--- ccp4srs-old/ccp4srs/ccp4srs_chicenter.h	2014-03-24 10:40:19.000000000 -0700
+++ ccp4srs/ccp4srs/ccp4srs_chicenter.h	2014-09-09 21:34:12.000000000 -0700
@@ -1,10 +1,10 @@
-//  $Id: ccp4srs_chicenter.h, v 1.00 2010/03/11 15:28:14 Eugene Exp $
+//  $Id: ccp4srs_chicenter.h $
 //  =================================================================
 //
 //   CCP4 SRS Library: Storage, Retrieval and Search support for
 //   CCP4 ligand data.
 //
-//   Copyright (C) Eugene Krissinel 2010.
+//   Copyright (C) Eugene Krissinel 2010-2013.
 //
 //   This library is free software: you can redistribute it and/or
 //   modify it under the terms of the GNU Lesser General Public
@@ -22,16 +22,16 @@
 //
 //  =================================================================
 //
-//    11.03.10   <--  Date of Last Modification.
+//    18.09.13   <--  Date of Last Modification.
 //                   ~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 //  -----------------------------------------------------------------
 //
 //  **** Module  :  ccp4srs_chicenter  <interface>
 //       ~~~~~~~~~
-//  **** Classes :  CCP4SRSChiCenter - chiral center class
+//  **** Classes :  ccp4srs::ChiCenter - chiral center class
 //       ~~~~~~~~~
 //
-//  (C) E. Krissinel 2010
+//  (C) E. Krissinel 2010-2013
 //
 //  =================================================================
 //
@@ -41,47 +41,50 @@
 
 #include "ccp4srs_atom.h"
 
-DefineClass(CCP4SRSChiCenter)
+namespace ccp4srs  {
 
-typedef char ChiCenterID[20];
+  DefineClass(ChiCenter);
 
-class CCP4SRSChiCenter  {
+  typedef char ChiCenterID[20];
 
-  // Chiral center signs
-  enum  {noSign,Positive,Negative,Both};
+  class ChiCenter  {
 
-  public:
-    CCP4SRSChiCenter();
-    virtual ~CCP4SRSChiCenter();
+    // Chiral center signs
+    enum  {noSign,Positive,Negative,Both};
 
-    inline cpstr    id    () { return chicenter_id; }
-    inline int      center() { return atom_center;  }
-    inline int      atom1 () { return atom_1;       }
-    inline int      atom2 () { return atom_2;       }
-    inline int      atom3 () { return atom_3;       }
-    inline int      sign  () { return volume_sign;  }
+    public:
+      ChiCenter();
+      virtual ~ChiCenter();
 
-    char get_chirality();
+      inline mmdb::cpstr id    () { return chicenter_id; }
+      inline int         center() { return atom_center;  }
+      inline int         atom1 () { return atom_1;       }
+      inline int         atom2 () { return atom_2;       }
+      inline int         atom3 () { return atom_3;       }
+      inline int         sign  () { return volume_sign;  }
 
-    static void makeCIFTags ( PCMMCIFLoop mmCIFLoop );
-    int  readFromCIF ( PCMMCIFLoop mmCIFLoop, int chiNo,
-                       CCP4SRSContainer<CCP4SRSAtom> & atoms );
-    void writeToCIF  ( PCMMCIFLoop mmCIFLoop, cpstr monID,
-                       CCP4SRSContainer<CCP4SRSAtom> & atoms );
+      char get_chirality();
 
-    void    write_mem ( PCMemIO memIO, int version );
-    Boolean read_mem  ( PCMemIO memIO, int version,
-                        Boolean * Ok = NULL );
+      static void makeCIFTags ( mmdb::mmcif::PLoop mmCIFLoop );
+      int  readFromCIF ( mmdb::mmcif::PLoop mmCIFLoop, int chiNo,
+                         Container<Atom> & atoms );
+      void writeToCIF  ( mmdb::mmcif::PLoop mmCIFLoop, mmdb::cpstr monID,
+                         Container<Atom> & atoms );
 
-    void copy ( PCCP4SRSChiCenter chicenter, ivector anmatch=NULL );
+      void write_mem ( PMemIO memIO, int version );
+      bool read_mem  ( PMemIO memIO, int version, bool * Ok = NULL );
 
-  protected:
-    ChiCenterID chicenter_id;    //!< chiral center id
-    int         atom_center;     //!< chiral center atom [0,1,...]
-    int         atom_1,atom_2;   //!< ordinal numbers of atoms that
-    int         atom_3;          //!< form the center [0,1,...]
-    int         volume_sign;     //!< chirality
+      void copy ( PChiCenter chicenter, mmdb::ivector anmatch=NULL );
 
-};
+    protected:
+      ChiCenterID chicenter_id;    //!< chiral center id
+      int         atom_center;     //!< chiral center atom [0,1,...]
+      int         atom_1,atom_2;   //!< ordinal numbers of atoms that
+      int         atom_3;          //!< form the center [0,1,...]
+      int         volume_sign;     //!< chirality
+
+  };
+
+}  // namespace ccp4srs
 
 #endif // CCP4SRS_CHICENTER_H
